config/routes.rb
# frozen_string_literal: true

Rails.application.routes.draw do
  # Define your application routes per the DSL in https://guides.rubyonrails.org/routing.html

  # Login/Register
  devise_for :users, controllers: {
    sessions: 'users/sessions',
    registrations: 'users/registrations'
  }

  # Root
  root to: 'home#index'

  # Patient pages
  get 'patient/home', to: 'patients#home'
  get 'patient/:id', to: 'patients#show'

  # Doctors pages
  get 'doctor/home', to: 'doctors#home'
  get 'doctor/:id', to: 'doctors#show'

  get 'doctors', to: 'doctors#index', as: :doctor_search

  # Appointments
  post 'appointment/:id/close', to: 'appointments#close', as: :close_appointment

  get 'doctor/:doctor_id/appointments/new', to: 'appointments#new', as: :new_appointment
  post 'doctor/:doctor_id/appointments/create', to: 'appointments#create', as: :create_appointment

  # Admin
  ActiveAdmin.routes(self)
end

app/models/doctor.rb
# frozen_string_literal: true

# == Schema Information
#
# Table name: users
#
#  id                 :bigint           not null, primary key
#  encrypted_password :string           default(""), not null
#  full_name          :string
#  phone_number       :string           not null
#  type               :string           not null
#  created_at         :datetime         not null
#  updated_at         :datetime         not null
#  doctor_category_id :integer
#
# Indexes
#
#  index_users_on_phone_number  (phone_number) UNIQUE
#
class Doctor < User
  has_many :appointments, dependent: :destroy
  has_many :patients, through: :appointments
  has_many :recommendations, through: :appointments, dependent: :destroy
  belongs_to :doctor_category, required: false

  validates :full_name, presence: true

  def appointments_full?
    appointments.open.size >= max_appointments
  end

  def max_appointments
    10
  end
end

app/controllers/doctors_controller.rb
# frozen_string_literal: true

class DoctorsController < ApplicationController
  def home
    @doctor = current_user
    authorize! :show, @doctor

    load_relations
    render 'show'
  end

  def show
    @doctor = Doctor.find(params[:id])
    authorize! :show, @doctor

    load_relations
  end

  def index
    authorize! :index, Doctor

    @doctor_categories = DoctorCategory.all
    doctors_query = params[:doctor_category] ? DoctorCategory.find(params[:doctor_category]).doctors : Doctor.all

    @doctors = doctors_query.includes(:doctor_category)
  end

  private

  def load_relations
    @recommendations = @doctor.recommendations.includes(appointment: [{ doctor: :doctor_category }, :patient])
    @appointments = @doctor.appointments.open.includes({ doctor: :doctor_category }, :patient)
  end
end

app/views/doctors/_item.html.erb
<div class="doctor_card card">
  <div class="doctor_info">
    <div class="doctor_name">
      Dr. <%= item.full_name %>
    </div>
    <div class="doctor_category">
      <% if item.doctor_category %>
        <span class="doctor_category_name">
          <%= item.doctor_category.name %>
        </span>
      <% end %>
    </div> 
  </div>
    <%= button_to 'Create appointment',
                  new_appointment_path(item),
                  method: :get,
                  data: { turbo: false },
                  form_class: 'doctor_actions',
                  disabled: item.appointments_full?
    %>
</div>

app/views/doctors/_search_form.html.erb
<div class="doctor_search search card">
  <%= form_with url: doctor_search_path, method: :get, class: 'search_form' do |form| %>
    <%= form.collection_select :doctor_category, doctor_categories, :id, :name %>
    <%= form.submit 'Select category' %>
    <%= link_to doctor_search_path, class: 'clear_form' do %>
      <%= button_tag 'Show All', type: 'button' %>
    <% end %>
  <% end %>
</div>

app/views/doctors/index.html.erb
<%= render partial: 'doctors/search_form', locals: { doctor_categories: @doctor_categories } %>
<div class="doctor_list">
  <%= render partial: 'doctors/item', collection: @doctors %>
</div>

app/views/doctors/show.html.erb
<div class="user_card card">
  <div class="header">
    <p><%= format 'EMPLOYEE FILE #%07d', @doctor.id %></p>
    <p>EMPLOYEE NAME: Dr. <%= @doctor.full_name %></p>
    <% if can? :read_number, @doctor %>
      <p>WORK NUMBER: <%= @doctor.phone_number %></p>
    <% end %>
  </div>

  <h3>Open Appointments:</h3>
  <%= render partial: "appointments/item", collection: @appointments %>

  <h3>Recommendations given:</h3>
  <%= render partial: "recommendations/item", collection: @recommendations %>
</div>